エンコーディングされている文字コードはどのように確認できますか?

投稿者: Anonymous python3.xにおいて、urllib.requestモジュールを使用して、得られたデータをutf-8でデコードしたところ以下のようなエラーが発生しました。 f = urllib.request.urlopen(‘http://www.google.com’) text = f.read().decode(“utf-8”) Traceback (most recent call last): File “<stdin>”, line 1, in <module> UnicodeDecodeError: ‘utf-8’ codec can’t decode byte 0x90 in position 102: invalid start byte つきましては以下2点をお教えください。 ・エラーの原因はアクセスしたURLで得られたHTMLファイルの文字コードがUTF-8ではないからという理解であっていますか? ・アクセス先のウェブページの文字コードの確認はどのようにすれば良いのでしょうか? よろしくお願いいたします。 解決 そうですね。確認すると確かにShiftJISで書かれています。 標準ライブラリで頑張るなら、 import cgi _v, param = cgi.parse_header(f.getheader(‘Content-Type’) or ”) text = f.read().decode(param.get(‘charset’, ‘utf-8’)) とでもするといいでしょうか。 でも、Pythonのurllib.requestの公式ドキュメントの冒頭に”お奨めです”と書いてあるとおり、requestsライブラリを使った方が、自分で頑張るよりずっとずっとお奨めです。 http://docs.python-requests.org/en/master/…(Continue Reading)

この2つのコードのどこが異なるのか教えて下さい。

投稿者: Anonymous python3系で除算をしたあとの整数への変換にいつもint()を使っていましたが、AtCoderの他の人の回答を見ると//を使用していました。 a = 3 / 2 print(int(a)) # 今までのやり方 a = 3 // 2 print(a) # 正しいやり方(?) 確かにAtCoderでもint()を使うと間違いと判定され、//に変えてみたところ正解になった問題がありました。 自分では違いが全くわかっていませんが、全然違うものなのでしょうか? 追記:質問の仕方が悪かったので補足します。 int()を使う場合と//を使う場合出力される結果は同じになると思いますが、AtCoderでコードを提出したところint()で整数に変換したものは間違いと判定されてしまいました。 //で最初から整数値のみを算出したものは正解と判定されたので不思議と思って質問しました。 それぞれの意味はおおまかには理解していますが、結果が変わる場合があることは認識していませんでした。 違う結果が出力される場合はどのようなときなのでしょうか? 参考までにそれぞれのコードを貼っておきます。 # 間違いと判定されたコード n, a, b = map(int, input().split()) if (b – a) % 2 == 0: ans = (b-a)/2 else: ans = min(a-1, n-b) + 1 + (b-a-1)/2…(Continue Reading)

VSCode で Python スクリプトを実行すると SyntaxError: Non-ASCII character ‘xe3’

投稿者: Anonymous タイトルの通りです。言語はPython3です。IDLEで作って動いてたコードを、VS codeで実行すると SyntaxError: Non-ASCII character ‘xe3’ in file /Users/TAKA/Downloads/SpaceTAKA/ランダム俳句.py on line 1, but no encoding declared; see http://python.org/dev/peps/pep-0263/ for details と表示されます。これはどういうことでしょうか?よろしくお願いします。 解決 エラーメッセージの指摘は、 「/Users/TAKA/Downloads/SpaceTAKA/ランダム俳句.pyというファイルにASCIIではない文字[(unicodeなどの多バイト文字コードの文字(漢字、ひらかな等))]が含まれている。 それなのに、["# coding: UTF-8"というような]使用文字コードの宣言が為されていない。」という事です。 ([]内は、私が補足した部分) /Users/TAKA/Downloads/SpaceTAKA/ランダム俳句.pyの先頭に、"# coding: UTF-8"という行を追加したら解決するのではないかと思われます。 回答者: Anonymous

文字列からアカウントだけを取得する

投稿者: Anonymous 実装したい内容 CSVで書き込んだ(tweet.text)から取得したtextのツイートを@mikipddw2on11のみ取得したいです。 ツイート(text) RT @mikipddw2on11: 今日の天気 #PR https://t.covIC68vSr4545 RT @mikipddw2on11:の文字から始まりますが、別のツイートからRTがない場合 今日の天気から文字はじめます。 取得したいのは、@mikipddw2on11のみだけです。 文字列は毎回異なりますが、RTがない場合、セルを空白にしたいです。 実装とエラー 他の方から別の質問にて正規表現でマッチさせる方法があると教えていただきましたが、 下記の2パターンの方法でやってみましたが、下記のようにエラーが表示されます。 コード① import tweepy import csv import re consumer_key = “” consumer_secret = “” access_key = “” access_secret = “” auth = tweepy.OAuthHandler(consumer_key, consumer_secret) auth.set_access_token(access_key, access_secret) api = tweepy.API(auth) #ツイート取得 tweet_data = [] data = api.get_user for tweet…(Continue Reading)

PythonのClassの実行する順番について

投稿者: Anonymous Pythonのクラスについてお聞きしたいのですが、クラス内のdefは上から順番に読み込まれていくのではないのでしょうか? 以下のようなプログラムがあります。 class API(Person): def __init__(self, FBtoken): # Facebookのトークンを元に、tinderのトークンを取得します。 params = {“token”: FBtoken} with requests.Session() as s: headers = { “User-Agent”: “Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36”} s.headers.update(headers) response = s.post( “https://api.gotinder.com/v2/auth/login/facebook”, data=json.dumps(params)) if response.status_code == 401: # 予期せぬトラブル sys.exit(1) data = json.loads(response.text)[“data”] self.id = data[“_id”]…(Continue Reading)

WEBスクレイピングができない

投稿者: Anonymous PythonでWEBページをスクレイピングし、あるサイトから店名と住所情報を取得したいと考えています。 コラボラトリー環境で以下のコードを試してみたのですが、情報を取得できません。 コードのどこがいけないのかスクレイピングに詳しい方教えていただけませんでしょうか? !pip install geocoder import requests import pandas as pd from bs4 import BeautifulSoup from google.colab import files import os import geocoder from time import sleep from google.colab import files url1 = "https://www.aeon.com/store/list/%E7%B7%8F%E5%90%88%E3%82%B9%E3%83%BC%E3%83%91%E3%83%BC/%E3%82%A4%E3%82%AA%E3%83%B3%E3%83%BB%E3%82%A4%E3%82%AA%E3%83%B3%E3%82%B9%E3%82%BF%E3%82%A4%E3%83%AB/p_" url2 = "/?q=aeoncom" cols = [‘store_name’,’address’,’latlon’] df = pd.DataFrame(index=[],columns=cols) for i in range(1,22): response = requests.get(url1 + str(i)…(Continue Reading)

pythonの例外処理は遅くない?

投稿者: Anonymous 今までC++やC#を触っていたのですが、たまにpythonも触っていました。 先日pythonのイテレータを見ていたら、イテレータの終了がraise StopIteration()で規定されていて、違和感を感じました。 C#等では「例外のcatchはかなり遅い」というのが常識だと思っていました。 少なくとも、こういう場面で安易に用いるようなものではないと思います。 もしかして、pythonでは例外処理はそこまで遅くないのでしょうか?高頻度でraiseしても大丈夫でしょうか? 解決 同じ質問が英語の方でありました。 https://stackoverflow.com/questions/20115954/would-a-stopiteration-make-python-slow 要は StopIteration に関してはコストが大きくならないように対処されていて、そのへんはPEP0234で言及されているとのことです。 https://www.python.org/dev/peps/pep-0234/ Pythonでもほかの例外の捕捉のコストは基本大きいですよ。ドキュメントに書いてあるとおり、 実際に例外を捕捉するのは高価です。 (※ただし StopIteration は除く) です。 回答者: Anonymous

mypy で Iterable[Optional[type]] から Iterable[type] を導出したい

投稿者: Anonymous 今、 mypy を用いて開発を行なっています。 Iterable[Optional[type]] があったとき、これを Iterable[type] に変換する関数を記述しようと思い、次のコードを記述しました。 from typing import Optional, Iterable def remove_none(iterable: Iterable[Optional[int]]) -> Iterable[int]: return filter(lambda x: x is not None, iterable) しかし、これは以下のエラーになります。 test.py:5: error: Argument 2 to “filter” has incompatible type “Iterable[Optional[int]]”; expected “Iterable[int]” 質問 Iterable の中身から Optional を外すのは、割と一般的な行為だと思われますが、これは、 mypy でエラーにならないで実装するのは、一般的にどのように行われますか? 解決 地道な方法 地道に下の通り書くと型チェックを通りました。 def remove_none_iterator(it: Iterator[Optional[int]]) -> Iterator[int]:…(Continue Reading)

Python 共有フォルダのファイル ディレクトリ指定について

投稿者: Anonymous S3にファイルをアップロードするコードになります。 ローカルPCのデスクトップやドキュメントからファイルを置くと問題なくS3にUPできますが、 ファイルを共有フォルダに置くと「指定したディレクトリが見つからない」とエラーが出ます。 共有フォルダからUPする際にどのように指定するば良いか。 教えていただけますでしょうか。 お手数ですが、宜しくお願いいたします。 現状のコード import boto3 accesskey = "11111111111111" secretkey = "11111111111111" region = "ap-northeast-3" s3 = boto3.client(‘s3’, aws_access_key_id=accesskey, aws_secret_access_key= secretkey, region_name=region) filename = r"¥¥192.111.10.111¥共有フォルダ¥マーケ¥test¥test.csv" bucket_name = "test" s3.upload_file(filename,bucket_name,filename) print("uploaded {0}".format(filename)) エラー内容 No such file or directory 解決 Teratailに投稿された以下の質問と回答が参考になるかもしれません。 awsのs3にファイルアップロード日本語 回答者: Anonymous

djangoの導入ができません

投稿者: Anonymous djangoのインストールはできています。 シェルでdjangoをimportとして、バージョンを表示させようとしても以下のエラーが出ます。 AttributeError: module ‘django’ has no attribute ‘version’ 解決方法を教えてください。 解決 >>> django.VERSION (2, 0, 4, ‘final’, 0) こうすべきところで、以下のようにしてるのではないですかね? >>> django.version Traceback (most recent call last): File “<stdin>”, line 1, in <module> AttributeError: module ‘django’ has no attribute ‘version’ 回答者: Anonymous

pyhon3 掛算リストで末尾に半角スペースを入れないで作成する仕方を教えてください。

投稿者: Anonymous python3の入門をしている者ですが、 以下の条件を満たすコードをよりシンプルに書くには どのような方法があるのでしょうか。 条件: ・入力値に対して、1から10をかける ・各整数の間に、半角スペース ・最終値の後ろに半角スペース、または改行が入るのはNG 私のコード: num = int(input()) for i in range(1, 11): if i == 10: print(i * num) else: print(str(i * num) + ” “, end=””) 入力: 2 出力: 2 4 6 8 10 12 14 16 18 20 解決 こんな感じでできます。 num = int(input()) print(” “.join(str(i * num)…(Continue Reading)

PyInstallerでDLL等の保存先を変更したい

投稿者: Anonymous お世話になります。 PyInstallerでDLLやPYDファイルの保存先ディレクトリを変更したいと考えています。 一応下記の英語版にある質問の1番目の回答で、とりあえず、実現できることは確認できました。 python – pyInstaller changing dll and pyd output location ですが、この方法を用いてもWxPythonを利用したプログラムで、WxPythonのDLLの保存先を変更することはできないようです。 環境はWindows10、Python3.7です。 長くなりますが、スクリプトと実行したコマンド、エラー内容を記載します。 スクリプト  下記スクリプトを「clock.py」として作成する。 import wx from datetime import datetime from pubsub import pub from time import sleep from threading import Thread class mainFrame(wx.Frame): def __init__(self): wx.Frame.__init__(self, None, -1, size = wx.Size(800, 400)) self.SetTitle(“時計”) mainScreen(self) class mainScreen(wx.Panel): def __init__(self, parent):…(Continue Reading)

pythonにおけるhashlibについて

投稿者: Anonymous windows10にてpython3.4でhashlibを使うため、pip install hashlibを行ったところ、以下のエラーが発生してしまいました。解決法、または代替可能なライブラリなどを教えていただけますと幸いです。 raise ValueError, “unsupported hash type” 解決 pipを使ってinstallしなくてもpython3.4であれば、ふつうにimport hashlibで使えるようになると思います。 回答者: Anonymous

ディレクトリを取得すると、場合によっては、スラッシュとバックスラッシュが入り混じるのはどうしてでしょうか?

投稿者: Anonymous from PySide import QtGui from PySide import QtCore import sys import os class DirectoryPrinter(QtGui.QWidget): def __init__(self,parent=None): super(DirectoryPrinter,self).__init__(parent=None) self.filedialog_pushbutton = QtGui.QPushButton(“filedialog”,self) self.connect(self.filedialog_pushbutton,QtCore.SIGNAL(“clicked()”),self.filename_getter) def filename_getter(self): print(“os.getcwd()から得られたディレクトリです。”,os.getcwd()) filename = QtGui.QFileDialog.getOpenFileName(self,”ファイルを選択”,os.path.expanduser(“~”))[0] print(“QFileDialogから得られたFileDialogの名前です。”,filename) def main(): try: QtGui.QApplication([]) except Exception as e: print(22,e) directoryprinter = DirectoryPrinter() directoryprinter.show() sys.exit(QtGui.QApplication.exec_()) if __name__ == “__main__”: main() 結果 os.getcwd()から得られたディレクトリです。 J: QFileDialogから得られたディレクトリです。 C:/Users/*******/hello.py スラッシュが全く逆になる現象です。…(Continue Reading)

reversed関数を使わずにリストの要素を逆順にする関数を作ろうとしたがエラーが出る

投稿者: Anonymous リストを引数xとし、xの要素を逆順に並べたリストを返す関数を作りたいのですが、 def num5(x): for i in range(len(x)): x[i] = y[-(i+1)] return y 以上のコードだと num5([1,2,3,4,5]) を実行した場合、 ————————————————————————— TypeError Traceback (most recent call last) <ipython-input-21-c2a7a4692d72> in <module>() 3 x[int(i)] = y[-int(i+1)] 4 return y —-> 5 num5([1,2,3,4,5]) <ipython-input-21-c2a7a4692d72> in num5(x) 1 def num5(x): 2 for i in range(len(x)): —-> 3 x[int(i)] = y[-int(i+1)] 4 return…(Continue Reading)

配列から0.1のみをとりだす方法、

投稿者: Anonymous matplotlib-quiverで東西、南北の風速を可視化しています。 U=nc2[‘uwnd_c’][0][0][0] V=nc2[‘vwnd_c’][0][0][0] plt.quiver(U,V,angles=’xy’,scale_units=’xy’,scale=0.5) で出力すると この画像が出ます。 やりたいことは、U==1.0、V==1.0のとき地図上に矢印を書きたいです。 そこで if U==1.0 or V==1.0: plt.quiver(U,V,angles=’xy’,scale_units=’xy’,scale=0.5) else: pass をやると The truth value of an array with more than one element is ambiguous. Use a.any() or a.all() のエラーが出ます。 調べてもわかりませんでした。 どこがまちがっているのでしょうか。 参考にしたサイト https://algorithm.joho.info/programming/python/matplotlib-quiver/ 解決 質問内容から推測すると、以下のような感じでしょうか。 UとVが2次元の数値配列 U[y][x]またはV[y][x]のどちらかの値が1.0だったら有効なデータとし、それ以外の値の場合は両方とも0.0に置き換える 0.0に置き換えた所は、小さな点になって残るので、まだ完全では無いですが、 だいたいこんな処理になるのでは? rows = U.shape[0] cols = U.shape[1] for iy in…(Continue Reading)

pythonのDjangoでのmigration

投稿者: Anonymous pythonのDjangoを使用して、Webアプリケーションを作りたいと思っています。 現在は、初期設定を行なっています。 ですが、下記のようにそのようなモジュール名のファイルはありませんと記載されてしまい、 どのようにすればマイグレーションできるのかわかりません。 $ python manage.py migrate File “manage.py”, line 8, in <module> from django.core.management import execute_from_command_line ImportError: No module named django.core.management Djangoはインストールできています。 $ pip freeze Django==1.8 インターネットで検索をして似たような内容はあるのですが、 具体的な操作の回答はなかったので、教えていただけないでしょうか? 解決 こちらの件ですが、pythonのバージョンが古くて表示されたエラーでした。 http://graphbooth.com/2017/05/31/pythonmac.html 上記のサイトを見ながら解決させていただきました。 djangoのバージョンとphthonのバージョンが合っていなかったようです。 お答えくださった方すみません。 回答者: Anonymous

pythonにおいてtxtファイルからある範囲の行を取り出しdataframe化したいです。

投稿者: Anonymous txt ファイルの中身には 日付 1日中の1時時間刻みの 風向、風速のデータが 連続で記録されております。 例) 2019 1 1 /n 289 1 264 0.1 254 0.8 86 0.4 ……. /n 70 0.8 270 0.56 287 0.67 30 0.25 ……. /n 2019 1 2 /n 274 2 255 0.13 257 0.22 254 0.12 ……. /n 270 0.15 242 0.77 233 0.11 244 0.75 ……. /n ….. データから2~3行目の中身を取り出し奇数の所をdf[wind_dir]、偶数の所をdf[wind_speed] 後、1行目中身を日付として後ろに時間を貼り付け、df[time]に作ればいいと思いますが pythonがまだ未熟なので、考え方をそのまま実行できないです。 お手数ですが、良い方法を教えてください。 風向、風速データはスペースで区分されており、奇数が風向、偶数が風速 日付のデータもスペースで区分されております。   解決 基本的に、毎日 00:00 からの24時間分のデータがあることを前提にしてみました。 風向きは北北東を22.5度から始める16方位で、北を360.0度、静穏を0.0にしています。 import pandas as pd # 時刻追加用文字列 times = [ ’00:00′,’01:00′,’02:00′,’03:00′,’04:00′,’05:00′,’06:00′,’07:00′, ’08:00′,’09:00′,’10:00′,’11:00′,’12:00′,’13:00′,’14:00′,’15:00′, ’16:00′,’17:00′,’18:00′,’19:00′,’20:00′,’21:00′,’22:00′,’23:00′ ]…(Continue Reading)

Python PIL ImageTkでRuntimeErrorが発生する。

投稿者: Anonymous Tkを使用して、Imageファイルを描画しているのですが、部分テストのために、一部のダイアログのみ描画配置などを確認するため、ソースコードを一部流用していました。 今まで動作していた以下の関数からエラーが発生しました。 def LoadImage(self): self.img_single = self._chk_image_file_(“.\icon\mon_s.gif”) self.img_single = ImageTk.PhotoImage(self.img_single) return エラーの内容 RuntimeError: Too early to create image Exception ignored in: <bound method PhotoImage.__del__ of <PIL.ImageTk.PhotoImage object at 0x0000029C4F87A9E8>> Traceback (most recent call last): File “C:Program Files (x86)Microsoft Visual StudioSharedAnaconda3_64libsite-packagesPILImageTk.py”, line 123, in __del__ name = self.__photo.name AttributeError: ‘PhotoImage’ object has no attribute…(Continue Reading)

シーケンス対象となっているリストは、popで取り出しても、内容が不変だから、その原因がどうしてなのかということと、順に取り出す方法を知りたい。

投稿者: Anonymous import itertools value_text = [[‘an applean orange’, ‘an orangean apple’], [‘a pena ball’, ‘a balla pen’]] value_text = itertools.product(*value_text) solid_text = [‘I have ‘, ‘.You have ‘, ‘.’] copy_text = solid_text[:] text_seq = [] new_seq = [] for k,text in enumerate(value_text): length = len(solid_text) + len(text) pri_text = list(text[:]) for j in range(length):…(Continue Reading)

VSCodeで仮想マシン上のPythonを利用したい

投稿者: Anonymous * teratailでも投稿してはいますが解決できておりません。 マルチポストとなり申し訳ないです。 実現したいこと VScodeで、pythonインタープリタを追加したい。 困っていること VScodeのユーザー設定で、python.pythonPath部分に、仮想環境上にあるpython環境のパスを記述しても、インタープリタを選択しようとした時に、選択肢として出てこない。 該当ソースコード {“python.pythonPath”: “/Users/usernamexxx/xxx/.vagrant/venv/bin/python3.6”} 試したこと ターミナルから、仮想環境に入り、”Code”コマンドでVScodeを起動する方法も試したが、 「コマンド’code’は見つかりませんでした」となった。 VScodeで、PATHにCodeコマンドを追加した後もうまくいかず。。。 動作環境 PC: MacBookPro  OS: High sierra VM: Virtual Box 仮想環境:vagrant ゲストOS:ubuntu16.04 Python3: 3.6.4 追記: 実行しようとしていたのは、ゲスト上にインストールしたPythonです。 ホスト上は /Users/username/.pyenv/versions/3.6.4/bin/python ゲスト上は /home/vagrant/work/venv/bin/python にそれぞれインストールし直しました。 その後 {“python.pythonPath”: “/home/vagrant/work/venv/bin/python”} と記述したのですが、このpathでゲスト上の python ということは認識されるのでしょうか? ホスト上の pythonから codeコマンドを実行すると、VScodeを起動できます。また、ゲスト上の pythonでも、hoge.py を実行できました。 解決 どうも仮想マシンを利用していることで混乱があるようです。まず以下の点を確認しつつ作業すると解決に近付くかと思います。 実行しようとしている /Users/usernamexxx/xxx/.vagrant/venv/bin/python3.6 はどういった物ですか? Mac(ホスト)上でインストールしたPython: もしこれであれば、Vagrantで作った仮想環境とは関係無いことになります。 動作環境はMac…(Continue Reading)

djangoのmodelに後からauto_now_addを加える場合の処理の方法について

投稿者: Anonymous 標記に関し、質問致します。 models.py に、後からcreated_atというフィールドを加え、 auto_now_add=True としてフィールドを設定したのですが、 下記のところから何を入れれば先に進めるのかわからず止まりました。 python manage.py makemigrations You are trying to add the field ‘created_at’ with ‘auto_now_add=True’ to resultreport without a default; the database needs something to populate existing rows. 1) Provide a one-off default now (will be set on all existing rows) 2) Quit, and let me add a default…(Continue Reading)

pyqt5でのmatplotlibによるグラフ表示がうまくいかない

投稿者: Anonymous python3.5を使っています。pyqt5でmatplotlibを使ってみたところ、matplotlibで使えていた一部の機能が使えなくなりました。具体的にはx、y軸のラベル、グラフのタイトルが表示されないほか、x、y軸の表示範囲設定ができなりました。コードをどのように直せばよいのでしょうか。 import sys from PyQt5 import QtWidgets from PyQt5.QtCore import * from PyQt5.QtGui import * from PyQt5.QtWidgets import * from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas from matplotlib.backends.backend_qt5 import NavigationToolbar2QT as NavigationToolbar import matplotlib.pyplot as plt import random import numpy as np class Window(QtWidgets.QDialog): def __init__(self, parent=None): super().__init__(parent) self.setWindowTitle(“グラフ”) self.setGeometry(300,300,500,500) self.figure = plt.figure() self.axes…(Continue Reading)

プログラム内のどの部分でintの”0″を出力するよう指示しているのか

投稿者: Anonymous 問題のコードは以下の通りです。 for y in range(15): for x in range(20): if(y%4==3):field[y][x]=’#’ elif x%2==0 :field[y][x]=’ ‘ print(field[y][x], end=”)#” 0″と” 0″の間にspace print() 見る限りどこで0を出力させているのか私には分かりませんでした。 因みに出力結果は 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 #################### 0…(Continue Reading)

Python スクリプト実行時にエラー: “NameError: name ‘Color’ isn’t defined”

投稿者: Anonymous 私は「これからのロボットプログラミング入門」という本を読み進めています。EV3 MIND STORMをPythonでプログラミングしようというやつです。専門用語が多くなってしまうので、実際にこの教材を進められた方にのみわかる質問文となっていますのでご了承ください。 本題です。P.68の「ステータスライトを光らせる」についてです。Pythonでの記述方法がその隣に載っているのですが、それを実行するとエラーが出ます。 #!/usr/bin/env pybricks-micropython from common import * brick.light(Color.ORANGE) wait(2000) を実行すると NameError: name ‘Color’ isn’t defined となります。common.pyにも間違いを何度も探しました。こちらです。 #!/usr/bin/env pybricks-micropython from pybricks import ev3brick as brick from pybricks.ev3devices import Motor, InfraredSensor, UltrasonicSensor, from pybricks.parameters import Port, ImageFile, SoundFile from pybricks.tools import wait, StopWatch from pybricks.robotics import DriveBase ネットで調べても該当例がなかったので質問させていただきました。お心当たりのある方いらっしゃっいましたら是非ご回答をお願いします。 解決 その本のことは何も知らないですが、Color を足すとよさそうです。 修正前:…(Continue Reading)

Pythonをタスクスケジューラで起動したときのエラーについて

投稿者: Anonymous Windows10環境のタスクスケジューラよりPythonを起動し、win32comを利用してOutlookからメールを送信しようとしていたのですが、以下のエラーが発生してしまいメールが送信できずに困っております。 どなたか回避策等ご存知でしたらご教示願えますでしょうか。 ※ VSCode上からの実行では問題なく送信できています。。。 2018-04-25 22:06:12,455 – logExample – ERROR – Error do something: (-2146959355, ‘サーバーの実行に失敗しました’, None, None) Traceback (most recent call last): File “C:Program FilesPythonPython3.6.5libsite-packageswin32comclientdynamic.py”, line 89, in _GetGoodDispatch IDispatch = pythoncom.connect(IDispatch) pywintypes.com_error: (-2147221021, ‘操作を利用できません’, None, None) During handling of the above exception, another exception occurred: Traceback (most recent call last): File…(Continue Reading)

指定したURLの内容を表示したい

投稿者: Anonymous beutifulsoupを使ってます。指定したURLが出力されません。 html = urlopen(“https://qiita.com/”) z = html print(z) 上記で、urlopenを使って使ってurlを読み込んでからzに代入し、printで出力しても http.client.HTTPResponse object at 0x028199D0 のように吐き出されてしまい、https://qiita.com/の文字列が出力されません。 どなかたわかるかた教えていただければ幸いです。 解決 urllib.request.urlopen はこの場合では http.client.HTTPResponse を返すのでそれがそのとおりに表示されています.基本的にはドキュメンテーションを読むのが良いでしょうが(あるいは beautifulsoup 使うなら直接渡せそうですけども), https://qiita.com/ が欲しいならおおよそ #!/usr/bin/env python3 import urllib.request with urllib.request.urlopen(‘http://qiita.com’) as r: print(r.url) でよいとおもいます. 回答者: Anonymous

Xcodeでのpython3の使用について

投稿者: Anonymous 環境 Sierra10.12.6 Xcode 9.2 python 3.5.1を使用しています. ターミナル上で/usr/bin/pythonを実行したところ,正常に作動し,バージョンも3.5.1と表示されました. しかしXcode上でschemaのExecutableを/usr/bin/pythonとして実行したところ The run destination My Mac is not valid for Running the scheme というエラーが発生し作動しません. which /usr/bin/pythonで実行したところ /Users/アカウント名/.pyenv/shims/python が表示されました. どなたか解決方法がわかる方がいらっしゃいますでしょうか. 宜しくお願い致します. 解決 /usr/bin/python は、’/Users/アカウント名/.pyenv/shims/python’からのソフトリンクではないかと思われます。Xcodeの場合、ソフトリンクでは動かないようです。 https://discussions.apple.com/thread/3240437 xcodeでpython3を動かすことについては、Mac(Xcode)でのpython3.5の設定についての質問もあって動作すると思われるので、もう一度設定の見直しをしてみてください。 なお、/usr/bin/pythonは、Appleが設定しているものなので勝手にソフトリンクに変えるのは適切な行為とは言えません。 回答者: Anonymous

変数の初期値設定の変更が結果に与える影響

投稿者: Anonymous CodilityのMaxSliceSumという問題 上記の問題を日本語で説明している記事 を解き、コンパイルして評価したのですが、テストケースA=[-10]の時に0ではなく-10を返すように修正する必要がわかったため、変数の初期値に問題で指定されている想定されうる最も小さい値を入れるコードにしました。 しかし、変更後のコードでは他のバグが生じてしまい、修正方法がわかりません。 変更前のコードでは、テストケースA=[3,2,-6,4,0]の時に5が返されて要求を満たしています。 変更前 def solution(A): maxsum = 0 start = 0 end = 0 for i in range(len(A)): tmp = A[i] for j in range(i+1, len(A)): if tmp + A[j] > maxsum: tmp = tmp + A[j] else: break if tmp > maxsum: maxsum = tmp return (maxsum) しかしながら、変更後のコードではA=[3,2,-6,4,0]の時に4が返されてしまうようになりました。 変更後…(Continue Reading)

時系列データで期間を限定する

投稿者: Anonymous kaggleのWalmart Recruiting Store Sales Forecastingに挑戦しています。 https://www.kaggle.com/c/walmart-recruiting-store-sales-forecasting pandasのデータフレームから2010年のみのデータを抽出したいのですが、 どのようなコードを書けばよいでしょうか? Dateは以下のコードでDatetime型にしました。 よろしくお願いいたします。 import pandas as pd import numpy as np train=pd.read_csv(“train.csv”) Date列全体をstrptime関数に入れることができないので、関数を用意して、apply関数で加工する import datetime def str2date(x): return datetime.datetime.strptime(x, “%Y-%m-%d”) 時間型に直した列データを、Date2に格納 train[‘Date2’] = train[‘Date’].apply(str2date) train=train.drop([“Date”],axis=1) Date2の型を確認 type(train.loc[5,’Date2′]) 解決 これで良いかと思います。 import pandas as pd df = pd.read_csv(‘train.csv’, parse_dates=[‘Date’]) print(df.loc[df[‘Date’].dt.year == 2010]) 回答者: Anonymous